/* Copyright (c) 2008 River Tarnell <river@wikimedia.org>. */
/*
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely. This software is provided 'as-is', without any express or implied
 * warranty.
 */
/* $Id: atomic_gcc4.c 56 2008-08-26 18:45:22Z river $ */

#include	"swatomic.h"

/*
 * sw_atomic_inc_
 */
void
sw_atomic_inc(volatile sw_atomic_t *x)
{
	__sync_fetch_and_add(x, 1);
}

sw_atomic_t
sw_atomic_inc_ov(volatile sw_atomic_t *x)
{
	return __sync_fetch_and_add(x, 1);
}

sw_atomic_t
sw_atomic_inc_nv(volatile sw_atomic_t *x)
{
	return __sync_add_and_fetch(x, 1);
}

/*
 * sw_atomic_dec_
 */
void
sw_atomic_dec(volatile sw_atomic_t *x)
{
	__sync_fetch_and_sub(x, 1);
}

sw_atomic_t
sw_atomic_dec_ov(volatile sw_atomic_t *x)
{
	return __sync_fetch_and_sub(x, 1);
}

sw_atomic_t
sw_atomic_dec_nv(volatile sw_atomic_t *x)
{
	return __sync_sub_and_fetch(x, 1);
}

/*
 * sw_atomic_add_ 
 */
void
sw_atomic_add(volatile sw_atomic_t *x, sw_atomic_t inc)
{
	__sync_fetch_and_add(x, inc);
}

sw_atomic_t
sw_atomic_add_ov(volatile sw_atomic_t *x, sw_atomic_t inc)
{
	return __sync_fetch_and_add(x, inc);
}

sw_atomic_t
sw_atomic_add_nv(volatile sw_atomic_t *x, sw_atomic_t inc)
{
	return __sync_add_and_fetch(x, inc);
}

/*
 * sw_atomic_sub_
 */
void
sw_atomic_sub(volatile sw_atomic_t *x, sw_atomic_t inc)
{
	__sync_fetch_and_sub(x, inc);
}

sw_atomic_t
sw_atomic_sub_ov(volatile sw_atomic_t *x, sw_atomic_t inc)
{
	sw_atomic_t i = __sync_fetch_and_sub(x, inc);
	return i;
}

sw_atomic_t
sw_atomic_sub_nv(volatile sw_atomic_t *x, sw_atomic_t inc)
{
	return __sync_sub_and_fetch(x, inc);
}

/*
 * sw_atomic_swap_
 */
void *
sw_atomic_swap_ptr_ov(void *volatile*valptr, void *newval)
{
	return (void *) __sync_lock_test_and_set(valptr, newval);
}

void
sw_atomic_swap_ptr(void *volatile *valptr, void *newval)
{
	sw_atomic_swap_ptr_ov(valptr, newval);
}
