/* Copyright (c) 2008 River Tarnell <river@wikimedia.org>. */
/*
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely. This software is provided 'as-is', without any express or implied
 * warranty.
 */
/* $Id: stats_thread.cc 60 2008-08-26 19:56:15Z river $ */

#include	<sstream>
#include	<string>

#include	<pthread.h>
#include	"unistd.h"

#include	<boost/archive/text_oarchive.hpp>

#include	"stats_thread.h"

stats_t stats;

namespace {

extern "C" void*
do_start_stats_thread(void *arg) {
	stats_thread *stat = static_cast<stats_thread *>(arg);
	stat->start();
	delete stat;
	return NULL;
}

} // anonymous namespace

void
stats_thread::accept_handler(int fd, configp const &)
{
	stats_thread *stat = new stats_thread(fd);
	pthread_t tid;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	pthread_create(&tid, &attr, &do_start_stats_thread, static_cast<void *>(stat));
}

stats_thread::stats_thread(int fd)
	: fd_(fd)
{
}

stats_thread::~stats_thread()
{
	close(fd_);
}

void
stats_thread::start()
{
	std::ostringstream strm;
	boost::archive::text_oarchive arch(strm);
	arch << stats;

	std::string data(strm.str());
	write(fd_, data.data(), data.size());
}

