/* Copyright (c) 2008 River Tarnell <river@wikimedia.org>. */
/*
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely. This software is provided 'as-is', without any express or implied
 * warranty.
 */
/* $Id: swatomic.h 60 2008-08-26 19:56:15Z river $ */

#ifndef SWATOMIC_H
#define SWATOMIC_H

#include	<pthread.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned long sw_atomic_t;

void sw_atomic_inc(volatile sw_atomic_t *);
sw_atomic_t sw_atomic_inc_ov(volatile sw_atomic_t *);
sw_atomic_t sw_atomic_inc_nv(volatile sw_atomic_t *);

void sw_atomic_dec(volatile sw_atomic_t *);
sw_atomic_t sw_atomic_dec_ov(volatile sw_atomic_t *);
sw_atomic_t sw_atomic_dec_nv(volatile sw_atomic_t *);

void sw_atomic_add(volatile sw_atomic_t *, sw_atomic_t);
sw_atomic_t sw_atomic_add_ov(volatile sw_atomic_t *, sw_atomic_t);
sw_atomic_t sw_atomic_add_nv(volatile sw_atomic_t *, sw_atomic_t);

void sw_atomic_sub(volatile sw_atomic_t *, sw_atomic_t);
sw_atomic_t sw_atomic_sub_ov(volatile sw_atomic_t *, sw_atomic_t);
sw_atomic_t sw_atomic_sub_nv(volatile sw_atomic_t *, sw_atomic_t);

void sw_atomic_swap_ptr(void *volatile *, void *);
void *sw_atomic_swap_ptr_ov(void *volatile *, void *);

#ifdef __cplusplus
}
#endif

#endif	/* !SWATOMIC_H */
